import SidebarLayout from 'layout/SideBarLayout'
import Header from 'components/atom/Header';
import Breadcrumbs from 'components/Breadcrumbs';
import {NavLink, useNavigate, useParams} from 'react-router-dom';
import {useTranslation} from 'react-i18next';
import {getProp, safe, Maybe, identity, isFunction} from 'crocks'
import CompaniesEditForm from '../form/CompaniesEditForm';
import {useCompany} from '../api/useCompany';
import {hasLength} from '@s-e/frontend/pred';
import Nullable from 'components/atom/Nullable';
import Button from 'components/Button';
import {useRef} from 'react';
import {CompaniesListRoute} from '../routes';

function CompaniesEditLayot() {
    const nav = useNavigate();
    const saveRef = useRef(identity);
    const {id} = useParams();
    const {data} = useCompany({id});
    const {t} = useTranslation('company', {keyPrefix: 'edit'});
    const {t: tglobal} = useTranslation();

    const breadcrumb = (
        getProp('name', data)
        .chain(safe(hasLength))
        .alt(getProp('id', data).chain(safe(hasLength)))
        .alt(Maybe.Just(t('new')))
        .option(null)
    );

    const send = () => {isFunction(saveRef.current) && saveRef.current();};

    return (
        <SidebarLayout>
            <Header>
                <>
                    <Breadcrumbs>
                        <Breadcrumbs.Item>
                            <NavLink to={CompaniesListRoute.props.path}>
                                {tglobal(CompaniesListRoute.props.translationKey, {ns: CompaniesListRoute.props.translationNs})}
                            </NavLink>
                        </Breadcrumbs.Item>
                        <Nullable on={breadcrumb}>
                            <Breadcrumbs.Item hideSlash>
                                <span className='font-semibold'>{breadcrumb}</span>
                            </Breadcrumbs.Item>
                        </Nullable>
                    </Breadcrumbs>
                    <div className='space-x-4'>
                        <Button.Nd onClick={() => nav(CompaniesyListRoute.props.path)}>{t`cancel`}</Button.Nd>
                        <Button onClick={send}>{t`save`}</Button>
                    </div>
                </>
            </Header>

            <div className='p-8'>
                <CompaniesEditForm saveRef={saveRef} />
            </div>
        </SidebarLayout>
    )
}

export default CompaniesEditLayot
